/*--------------------------------------------------------------------------*/
/*                                                                          */
/*      Filename: db30to24.cmd                                               */
/*                                                                          */
/*      Project:  AMU                                                       */
/*                                                                          */
/*      Description: Change Database structur from 3.x and 3.1x to 2.4x        */
/*                                                                          */
/*      Author: J.S.                                                         */
/*                                                                          */
/*      History:                                                            */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/*      (C) Copyright ADIC-GRAU , Inc. 1999                                      */
/*                                                                          */
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/* Set environment variable for database abba                       */
/*--------------------------------------------------------------------------*/
rem SET DB2DBDFT=ABBA
/*--------------------------------------------------------------------------*/
/*  Call REXX Functions            */
/*--------------------------------------------------------------------------*/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/****************************************************************************\
  Mainmenu, try 3 times is possible
\****************************************************************************/

'@echo off'
DO 3
  call SysCls
  say ""
  say ""
  say ""
  say ""
  say ""
  say "Ŀ"
  say "                                                                      "
  say "                                                                      "
  say "                                                                      "
  say " 1 = Change Database structure from Version 3.0x or 3.1x back to 2.4x "
  say "     Attention:   Make sure that AMU Software isn't running before    "
  say "                  execute Option 1                                    "
  say "                                                                      "
  say " 2 = End                                                              "
  say "                                                                      "
  say "                                                                      "
  say " Select an Option:                                                    "
  say ""
  cpos = SysCurPos(22,24)
  Option = translate(SysGetKey('NOECHO'))
  cls
  say ""
  say ""
  if Option = "1" then
  do
    call logon
    call db2start
    call db2backup
    call db2connect
    call export
    call droptables 
    call createtables
    call changedb2cfg
    call db2stop
    call db2start
    call db2connect
    call importtables
    call createindex
    call db2stop
    call bind
    exit
  end

  if Option = "2" then
  do
    cls
    EXIT
  end

end
exit

/*logon*/
logon:
        logon "amuadmin /p=rasputin"
return

/*db2start*/
db2start:
        db2start
return

/*db2connect*/
db2connect:
        db2 "connect to ABBA"
return

/*db2stop*/
db2stop:
        db2 "connect reset"
        db2stop
return

/*db2backup Database ABBA will save to C:\amu\db30to24*/
db2backup:
say ""
say " A backup from the actual database ABBA was created in C:\AMU\DB30TO24 "
say ""
        md "c:\amu\db30to24"
        db2 "backup database abba to c:\amu\db30to24"
return

/*export the tables coordinates, scoordinates and pool to c:\amu\db30to24*/
/*Only the columns which was used into AMU 2.40x was exported*/
export:
         db2 "export to c:\amu\db30to24\pool24 of del select CLASS, SUPER, SUB from amu.pool"
         db2 "export to c:\amu\db30to24\scoor24 of del select COORDINATE, VOLSER, CTYPE, CATTR, COWNER, USECOUNT, CRASHCOUNT, MEDIA, BUDSTATE, TIMESTMP, VTYPE, LOCKED from amu.scoordinates"
         db2 "export to c:\amu\db30to24\coor24 of del select COORDINATE, VOLSER, CTYPE, CATTR, COWNER, USECOUNT, CRASHCOUNT, MEDIA, BUDSTATE, VOWNER, TIMESTMP, VTYPE, LOCKED from amu.coordinates"

return

/*drop the tables coordinates, scoordinates and pool*/
droptables:
         db2 "drop table amu.pool"
         db2 "drop table amu.scoordinates"
         db2 "drop table amu.coordinates"
return

/*create the tables coordinates, scoordinates and pool*/
createtables:
/*AMU.COORDINATES*/   
        db2 "create table AMU.COORDINATES (COORDINATE CHAR (10) NOT NULL)"        
        db2 "alter table AMU.COORDINATES add COLUMN VOLSER VARCHAR (17) NOT NULL DEFAULT"
        db2 "alter table AMU.COORDINATES add COLUMN CTYPE CHAR (1) NOT NULL DEFAULT"
        db2 "alter table AMU.COORDINATES add COLUMN CATTR CHAR (1) NOT NULL DEFAULT" 
        db2 "alter table AMU.COORDINATES add COLUMN COWNER CHAR (1) NOT NULL DEFAULT"
        db2 "alter table AMU.COORDINATES add COLUMN USECOUNT SMALLINT NOT NULL DEFAULT"
        db2 "alter table AMU.COORDINATES add COLUMN CRASHCOUNT SMALLINT NOT NULL DEFAULT"
        db2 "alter table AMU.COORDINATES add COLUMN MEDIA CHAR (2)"
        db2 "alter table AMU.COORDINATES add COLUMN BUDSTATE CHAR (1)"
        db2 "alter table AMU.COORDINATES add COLUMN VOWNER CHAR (2)"
        db2 "alter table AMU.COORDINATES add COLUMN TIMESTMP TIMESTAMP"
        db2 "alter table AMU.COORDINATES add COLUMN VTYPE CHAR (1)"
        db2 "alter table AMU.COORDINATES add COLUMN LOCKED CHAR (16)"
/*AMU.SCOORDINATES*/   
        db2 "create table AMU.SCOORDINATES (COORDINATE CHAR (10) NOT NULL)"        
        db2 "alter table AMU.SCOORDINATES add COLUMN VOLSER VARCHAR (17) NOT NULL DEFAULT"
        db2 "alter table AMU.SCOORDINATES add COLUMN CTYPE CHAR (1) NOT NULL DEFAULT"
        db2 "alter table AMU.SCOORDINATES add COLUMN CATTR CHAR (1) NOT NULL DEFAULT" 
        db2 "alter table AMU.SCOORDINATES add COLUMN COWNER CHAR (1) NOT NULL DEFAULT"
        db2 "alter table AMU.SCOORDINATES add COLUMN USECOUNT SMALLINT NOT NULL DEFAULT"
        db2 "alter table AMU.SCOORDINATES add COLUMN CRASHCOUNT SMALLINT NOT NULL DEFAULT"
        db2 "alter table AMU.SCOORDINATES add COLUMN MEDIA CHAR (2)"
        db2 "alter table AMU.SCOORDINATES add COLUMN BUDSTATE CHAR (1)"
        db2 "alter table AMU.SCOORDINATES add COLUMN TIMESTMP TIMESTAMP"
        db2 "alter table AMU.SCOORDINATES add COLUMN VTYPE CHAR (1)"
        db2 "alter table AMU.SCOORDINATES add COLUMN LOCKED CHAR (16)"
/*AMU.POOL*/
        db2 "create table AMU.POOL (CLASS VARCHAR (17) NOT NULL)"
        db2 "alter table AMU.POOL add COLUMN SUPER VARCHAR (17) NOT NULL DEFAULT" 
        db2 "alter table AMU.POOL add COLUMN SUB VARCHAR (17) NOT NULL DEFAULT"
return

/* change logfilesize for secondary logfile from default 2 to 5, in case of big liberies (more than 6 Quadrotowers)*/ 
changedb2cfg:
db2 "update database configuration for abba using LOGFILSIZ 250 LOGSECOND 5"


return

/*import the tables coordinates, scoordinates and pool*/
importtables:
        db2 "import from c:\amu\db30to24\pool24 of del insert into amu.pool" 
        db2 "import from c:\amu\db30to24\scoor24 of del insert into amu.scoordinates" 
        db2 "import from c:\amu\db30to24\coor24 of del insert into amu.coordinates" 
return

/*the index will be created*/
createindex:
        db2 "create UNIQUE INDEX AMU.XCOORDINATE ON AMU.COORDINATES (COORDINATE)"
        db2 "create           INDEX AMU.XVOLSER        ON AMU.COORDINATES (VOLSER)"
        db2 "create           INDEX AMU.XCBUDSTATE  ON AMU.COORDINATES (BUDSTATE)"
        db2 "create           INDEX AMU.XSBUDSTATE  ON AMU.SCOORDINATES (BUDSTATE)"
return 

/*call arcbndit from actual amu version which is located in c:\amu*/
bind:
"c:"
cd "\"
cd "amu"
"call arcbndit.cmd"
return
 
/* End of program*/
